%%%%%%                 %%%%%%
% PERSONALITY,              %   
%    CREDIT CONSTRAINTS     %
%       AND SELF-EMPLOYMENT % 
%                           %
%                           %
% L A T E N T F A C T O R S %
%                           %
%                           %
%%%%%%                %%%%%%%


function st_err=ERRORS(th_ml)    

%   GLOBAL

global  id ...
		se_04 pe_04 learn1_04 ...
		se_95 pe_95 learn1_95 ...
		assets_95 assets1_95 lassets1_95 assets_95_sq  ...
		fluid episodic exec ...
		O_04 C_04 E_04 A_04 N_04 O_95 C_95 E_95 A_95 N_95 ...
		hs_04 scoll_04 cgrad_04  educ_04 ...
		hs_95 scoll_95 cgrad_95  educ_95 ...
		age_04 age_sq_04 age_95 age_sq_95 ...
		married_04 married_95 num_kids_04 ... 
        sp_educ_04 sp_se_95 sp_pe_95 sp_employ_95 ...
        pointer_latent pointer_beta_w pointer_beta_theta_0 ...
        pointer_e_theta_0 pointer_beta_a_0 pointer_nu_a_0 pointer_e_w_0 ...
        pointer_e_y_0 pointer_nu_y_0 pointer_nu_w_0 pointer_beta_u ... 
        pointer_alpha pointer_lambda ...     
        MODEL0 MODEL1 MODEL2 MODEL3 MODEL4 ... 
        ERRORS_CALC RESULTS DRAWS N N_p CHATTERING RANDU r li lip;     

    
S_A=zeros(N,N_p);

for p=1:N_p    

espx=nthroot(eps,10);   
h=1.10*(espx)*(abs(th_ml(p,1))); 
        
% espx=nthroot(eps,10);   
% h=1.05*(espx)*(abs(th_ml(p,1))); 

for g=1:2

    p 
    g ;
    h 
        
       
th_ml_P=th_ml;    
    
    
if g==1    
    th_ml_P(p,1)=th_ml(p,1)+h     ;
elseif g==2
    th_ml_P(p,1)=th_ml(p,1)-h     ;
end

ll_PER=LL(th_ml_P) ;

li_PER(:,g) = li   ;

if g==1
    
    ll_plus = -sum(li)  ;                                    

elseif g==2
    
    ll_minus = -sum(li)  ;   
 
    ll_diff = ll_plus-ll_minus
    lldiff(p,1)=ll_plus-ll_minus ;

end    
    
end    
    
S_A(:,p) = times((li_PER(:,1)-li_PER(:,2)),(1/(2*h)))  ;

end    

CHECK=transpose(sum(S_A))
lldiff
hist(lldiff)


AA=zeros(N_p,N_p); 
S_A_t=transpose(S_A);


for j=1:N
 Aj=S_A_t(:,j)*S_A(j,:);
 AA=AA+Aj;
end

%  AA
 
%See pp 395-6 of Wooldridge:

Avar=inv(AA);


for p=1:N_p
    st_errors(p,1)=sqrt(Avar(p,p));
end

st_errors

for p=1:N_p
p_values(p,1)=(2*(1-cdf('Normal',((abs(th_ml(p,1)))/st_errors(p,1)),0,1)));
end

st_err=[st_errors p_values];

end

